# -*- coding: UTF-8 -*-
import re
import json


def get_tags():
    return ['4', '4.11']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''ps -wef|grep "ftpd"|grep -v grep '''
    tmp_vars["systemvalue1"] = ""

    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = r'''grep -v "^[[:space:]]*#" /etc/vsftpd.conf 2>/dev/null | grep -i "^\s*ls_recurse_enable\s*="; grep -v "^[[:space:]]*#" /etc/vsftpd/vsftpd.conf 2>/dev/null | grep -i "^\s*ls_recurse_enable\s*=" '''
    tmp_vars["systemvalue2"] = ""

    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = r'''grep -v "^[[:space:]]*#" /etc/vsftpd.conf 2>/dev/null | grep -i "^\s*local_umask\s*="; grep -v "^[[:space:]]*#" /etc/vsftpd/vsftpd.conf 2>/dev/null | grep -i "^\s*local_umask\s*=" '''
    tmp_vars["systemvalue3"] = ""

    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = r'''grep -v "^[[:space:]]*#" /etc/vsftpd.conf 2>/dev/null | grep -i "^\s*anon_umask\s*=\s*"; grep -v "^[[:space:]]*#" /etc/vsftpd/vsftpd.conf 2>/dev/null | grep -i "^\s*anon_umask\s*=\s*" '''
    tmp_vars["systemvalue4"] = ""

    tmp_vars["checkresult5"] = "failed"
    tmp_vars["scancommand5"] = '''grep -v "^[[:space:]]*#" /etc/pure-ftpd.conf 2>/dev/null | grep -i "umask"; grep -v "^[[:space:]]*#" /etc/pure-ftpd/pure-ftpd.conf 2>/dev/null | grep -i "umask" '''
    tmp_vars["systemvalue5"] = ""

    tmp_vars["checkresult6"] = "failed"
    tmp_vars["scancommand6"] = '''grep -v "^[[:space:]]*#" /etc/ftpaccess 2>/dev/null |grep -i "upload"; grep -v "^[[:space:]]*#" /etc/ftpd/ftpaccess 2>/dev/null |grep -i "upload" '''
    tmp_vars["systemvalue6"] = ""

    tmp_vars["checkresult7"] = "failed"
    tmp_vars["scancommand7"] = r'''grep -v "^\s*#" /etc/proftpd.conf 2>/dev/null |grep -i "umask"; grep -v "^\s*#" /etc/proftpd/proftpd.conf  2>/dev/null |grep -i "umask" '''
    tmp_vars["systemvalue7"] = ""

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand2"])
    arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc2, astdout2, astderr2)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand3"])
    arc3, astdout3, astderr3 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc3, astdout3, astderr3)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand4"])
    arc4, astdout4, astderr4 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc4, astdout4, astderr4)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand5"])
    arc5, astdout5, astderr5 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc5, astdout5, astderr5)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand6"])
    arc6, astdout6, astderr6 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc6, astdout6, astderr6)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand7"])
    arc7, astdout7, astderr7 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc7, astdout7, astderr7)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1 = re.match(r"^\s*$", astdout1)
    tmp_vars["systemvalue1"] = astdout1
    if match1:
        tmp_vars["checkresult1"] = "pass"

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s." % astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2 = re.match(r"\s*ls_recurse_enable\s*=\s*YES", astdout2)
    tmp_vars["systemvalue2"] = astdout2
    if match2:
        tmp_vars["checkresult2"] = "pass"

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s." % astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3 = re.match(r"\s*local_umask\s*=\s*022", astdout3)
    tmp_vars["systemvalue3"] = astdout3
    if match3:
        tmp_vars["checkresult3"] = "pass"

    if arc4 != 0:
        return (-2, "Failed to invoke module: %s." % astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4 = re.search(r"\s*anon_umask\s*=\s*022", astdout4)
    tmp_vars["systemvalue4"] = astdout4
    if match4:
        tmp_vars["checkresult4"] = "pass"

    if arc5 != 0:
        return (-2, "Failed to invoke module: %s." % astdout5)
    resultjson5 = json.loads(astdout5)
    astdout5 = resultjson5["stdout"]
    astderr5 = resultjson5["stderr"]
    match5 = re.match(r".*177:077", astdout5)
    tmp_vars["systemvalue5"] = astdout5
    if match5:
        tmp_vars["checkresult5"] = "pass"

    if arc6 != 0:
        return (-2, "Failed to invoke module: %s." % astdout6)
    resultjson6 = json.loads(astdout6)
    astdout6 = resultjson6["stdout"]
    astderr6 = resultjson6["stderr"]
    match6 = re.search(r"upload\s+.*\s*644", astdout6)
    tmp_vars["systemvalue6"] = astdout6
    if match6:
        tmp_vars["checkresult6"] = "pass"

    if arc7 != 0:
        return (-2, "Failed to invoke module: %s." % astdout7)
    resultjson7 = json.loads(astdout7)
    astdout7 = resultjson7["stdout"]
    astderr7 = resultjson7["stderr"]
    match7 = re.match(r".*022", astdout7)
    tmp_vars["systemvalue7"] = astdout7
    if match7:
        tmp_vars["checkresult7"] = "pass"

    if tmp_vars["checkresult1"] == "pass" or (tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult3"] == "pass" and tmp_vars["checkresult4"] == "pass") or (tmp_vars["checkresult5"] == "pass") or tmp_vars["checkresult6"] == "pass" or tmp_vars["checkresult7"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_4_11.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
